<html>
<head>
  <script type="text/javascript" src="jquery-1.10.2.js"></script>
  <script src="fabric/fabric.js"></script>
</head>
<body>

  <canvas id="c" width="800" height="600"></canvas>

  <script>

var canvas = new fabric.Canvas("c");
canvas.hoverCursor = "default";
canvas.selection = false;

var n = 7
var blocks = [ [0,1,2], [2,3,4], [0,4,5], [1,4,6], [2,5,6], [0,3,6], [1,3,5] ];
//var n = 10;
//var blocks = [ [0,1,2,3], [0,1,4,5], [0,2,4,6], [0,3,7,8], [0,5,7,9], [0,6,8,9],
//               [1,2,7,8], [1,3,6,9], [1,4,7,9], [1,5,6,8], [2,3,5,9], [2,4,8,9],
//               [2,5,6,7], [3,4,5,8], [3,4,6,7] ];

var pointRadius = 20;
var radius = 150;
var centerX = 200;
var centerY = 200;
var angle = 180 - (n-2)*180/n ;
var startAngle = n % 2 == 1 ?  270 : 270 - angle / 2;
var colors = [];
var points = [];
var strPoints = [];
for (var i = 0; i < n; i++) {
  var x1 = centerX + radius * Math.cos(startAngle * Math.PI / 180);
  var y1 = centerY + radius * Math.sin(startAngle * Math.PI / 180);
  var x2 = centerX - 6 + (radius + pointRadius + 10) * Math.cos(startAngle * Math.PI / 180);
  var y2 = centerY - 6 + (radius + pointRadius + 10) * Math.sin(startAngle * Math.PI / 180);
  points.push({ x: x1, y: y1 });
  strPoints.push({ x: x2, y: y2 });

  startAngle += angle;
}

var pairs = {};
for (var i = 0; i < blocks.length; i++){
  var block = blocks[i];
  for (var j = 0; j < block.length; j++) {
    var n = (j + 1) % block.length;
    var p1 = block[j];
    var p2 = block[n];
    var order = [p1, p2].sort();
    var key = order[0] + "_" + order[1];
    if (pairs[key] == null)
      pairs[key] = 1;
    else pairs[key] = pairs[key] + 1;
  }
}

var pairCount = 0;
for(var key in pairs) {
  pairs[key] = pairs[key] - Math.ceil(pairs[key] / 2);
  pairCount += 1;
}

var frequency = .1;
for (var i = 0; i < blocks.length; i++){
  var rgb = [];
  //var red   = Math.sin(frequency*i + 0) * 127 + 128;
  //var green = Math.sin(frequency*i + 2) * 127 + 128;
  //var blue  = Math.sin(frequency*i + 4) * 127 + 128;
  //rgb = [red, green, blue];

  //var val = (255 - 10) / blocks.length * i;
  //rgb = [val, val, val];

  for(var k = 0; k < 3; k++)
    rgb.push(Math.floor(Math.random() * 255));
  colors.push(rgb);
}

for (var i = 0; i < points.length; i++){
  var circle = new fabric.Circle({
    radius: pointRadius, fill: 'rgba(255,0,0,0)',
    stroke: '#000', strokeWidth: 2,
    left: points[i].x - pointRadius, top: points[i].y - pointRadius,
    selection: false, hoverCursor: 'default',
    hasControls: false, hasBorders: false,
    lockMovementX: true, lockMovementY: true });
  canvas.add(circle);

  //var n = (i + 1) % points.length;
  //var line =new fabric.Line([points[i].x, points[i].y, points[n].x, points[n].y], {
  //  stroke: '#000000', hoverCursor: 'default',
  //  hasControls: false, hasBorders: false,
  //  lockMovementX: true, lockMovementY: true });
  //canvas.add(line);

  var str = new fabric.Text(i.toString(), { fontSize: 15, fontFamily: 'Consolas',
    left: strPoints[i].x, top: strPoints[i].y,
    hasControls: false, hasBorders: false,
    lockMovementX: true, lockMovementY: true });
  canvas.add(str);
}

for (var i = 0; i < blocks.length; i++){
  var block = blocks[i];
  for (var j = 0; j < block.length; j++) {
    var n = (j + 1) % block.length;
    var b1 = block[j];
    var b2 = block[n];
    var order = [b1, b2].sort();
    var key = order[0] + "_" + order[1];
    var count = pairs[key];
    pairs[key] = pairs[key] - 1;
    var p1 = points[b1];
    var p2 = points[b2];
    var diffAlpha = (count-1) * 8 * Math.PI / 180;
    var alpha = Math.atan((p2.y - p1.y) / (p2.x - p1.x));
    var p1x = p1.x - (pointRadius + 1) * Math.cos((p1.x > p2.x ? 0 : Math.PI) + alpha + diffAlpha);
    var p1y = p1.y - (pointRadius + 1) * Math.sin((p1.x > p2.x ? 0 : Math.PI) + alpha + diffAlpha);
    var p2x = p2.x - (pointRadius + 1) * Math.cos((p2.x > p1.x ? 0 : Math.PI) + alpha - diffAlpha);
    var p2y = p2.y - (pointRadius + 1) * Math.sin((p2.x > p1.x ? 0 : Math.PI) + alpha - diffAlpha);
    var color = 'rgb('+ colors[i].join(',') + ')';
    var line = new fabric.Line([p1x, p1y, p2x, p2y], {
      stroke: color, hoverCursor: 'default',
      hasControls: false, hasBorders: false,
      lockMovementX: true, lockMovementY: true });
    canvas.add(line);
    console.log(1);
  }
  console.log(1);
}

  </script>
</body>
</html>
